# U-BOOT TCL File
#
# (C) Copyright 2007 Michal Simek
#
# Michal  SIMEK <monstr@monstr.eu>
#
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#
# ChangeLOG:
# 1.01.b add Microblaze HW_VER support, FLAGS, Uart16550. Remove MSS drivers dependence, Timer handle throught INTC, BARREL shifter
# 1.01.a add MSR support and mch_opb_ddr
# 1.01.f add FSL support
# 1.01.e add IIC support
# 1.00.d clear Czech comments
# 1.00.c synchronization FLASH_MEMORY

# BUGS
# handle OPB_BUS

# Globals variable
set drvlist [list]

proc uboot_drc {os_handle} {
    puts "\#--------------------------------------"
    puts "\# uboot BSP DRC...!"
    puts "\#--------------------------------------"
}


proc generate {os_handle} {
    variable drvlist
    puts "\#--------------------------------------"
    puts "\# uboot BSP generate..."
    puts "\#--------------------------------------"


# Open config.mk file
    set config_file_name2 "config.mk"
    set config_file2 [open $config_file_name2 w]
# Print GPL
    headerm $config_file2
    puts $config_file2 ""


# open config files
    set config_file_name "xparameters.h"
    set config_file [open $config_file_name w]
# print GPL license
    headerc $config_file
    puts $config_file ""

    set proc_handle [xget_libgen_proc_handle]
# ************************************************************************************************************
# print system clock
    set sys_clock [xget_sw_parameter_value $proc_handle "CORE_CLOCK_FREQ_HZ"]
    puts $config_file "/* System Clock Frequency */"
    puts $config_file "#define XILINX_CLOCK_FREQ\t$sys_clock"
    puts $config_file ""

# ************************************************************************************************************
# EXAMPLE for finding proper OPB bus from MSS file - opbarb standalone driver

## vyborny test na nulovy pointer
#    if { [llength $baseaddr_handle] == 0 } {
#	return ""
#    }

## jak ziskat z parametru baseaddr k jake je pripojen sbernici
#    set intc [xget_sw_parameter_value $os_handle "intc"]
#    set periph_handle [xget_sw_ipinst_handle_from_processor $proc_handle $intc]
#    set busif_handle [xget_addrparam_busif $periph_handle "C_BASEADDR"]
#    set name [xget_value $busif_handle "NAME"]
#    set value [xget_value $busif_handle "VALUE"]
#    puts "xxxx $busif_handle xxxx  $name $value"

##ziskani vsech bus interface polozek
#    set ethernet [xget_sw_parameter_value $os_handle "ethernet"]
#    set periph_handle [xget_sw_ipinst_handle_from_processor $proc_handle $ethernet]
#    set busif_handle2 [xget_handle $periph_handle "BUS_INTERFACE" "*"]
#    foreach busif_handle $busif_handle2 {
#    	set name [xget_value $busif_handle "NAME"]
#	set value [xget_value $busif_handle "VALUE"]
#	puts "xxxx $busif_handle xxxx  $name $value"
#    }

##zjisteni cisla - handler na procesor
##ziskani cisla procesoru
#   set periph_handle [xget_handle $proc_handle "IPINST"]
#odkaz na vsechny bus interface
#   set busif_handle2 [xget_handle $periph_handle "BUS_INTERFACE" "*"]
#    foreach busif_handle $busif_handle2 {
#    	set name [xget_value $busif_handle "NAME"]
#	set value [xget_value $busif_handle "VALUE"]
#	puts "xxxx $busif_handle xxxx  $name $value"
#    }

##test na procesor
#   set periph_handle [xget_handle $proc_handle "IPINST"]
#   set dopb [xget_handle $periph_handle "BUS_INTERFACE" "DOPB"]
#   set dopb [xget_value $dopb "VALUE"]
#   set iopb [xget_handle $periph_handle "BUS_INTERFACE" "IOPB"]
#   set iopb [xget_value $iopb "VALUE"]
#   if { $dopb == $iopb } {
#	puts "same busses - Microblaze is connected to $iopb $dopb\n reference system bus for CPU 1"
#	set system_bus "$dopb"
#
#   } else {
#	error "different microblaze architecture - dual busses $iopb $dopb"
#   }


# ************************************************************************************************************
# Microblaze
    set hwproc_handle [xget_handle $proc_handle "IPINST"]
    set args [xget_hw_parameter_handle $hwproc_handle "*"]
    set proctype [xget_value $hwproc_handle "OPTION" "IPNAME"]
    switch $proctype {
        "microblaze" {
# write only name of instance
 	  foreach arg $args {
		set arg_name [xget_value $arg "NAME"]
		set arg_name [string map -nocase {C_ ""} $arg_name]
		set arg_value [xget_value $arg "VALUE"]
#		puts "DEBUG $arg_name $arg_value"
		switch -regexp $arg_name {
			INSTANCE {
				   	puts $config_file "/* Microblaze is $arg_value */"
					break;
			}
			default {}
		}
           }
 	  foreach arg $args {
		set arg_name [xget_value $arg "NAME"]
		set arg_name [string map -nocase {C_ ""} $arg_name]
		set arg_value [xget_value $arg "VALUE"]
#		puts "DEBUG $arg_name $arg_value"
		switch $arg_name {
			USE_MSR_INSTR {
				   	puts $config_file "#define XILINX_USE_MSR_INSTR\t$arg_value"
			}
			FSL_LINKS {
				   	puts $config_file "#define XILINX_FSL_NUMBER\t$arg_value"
			}
			HW_VER {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mcpu=v$arg_value"
			}
			USE_BARREL {
				if {[string match $arg_value "1"]} {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mxl-barrel-shift"
				}
			}
			USE_DIV {
				if {[string match $arg_value "1"]} {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mno-xl-soft-div"
				}
#FIXME What is -mno-xl-hard-div
			}
			USE_HW_MUL {
				if {[string match $arg_value "1"]} {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mno-xl-soft-mul"
				} else {
					puts $config_file2 "PLATFORM_CPPFLAGS += -mxl-soft-mul"
				}
#FIXME What is -mxl-multiply-high???
			}
			USE_PCMP_INSTR {
				if {[string match $arg_value "1"]} {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mxl-pattern-compare"
				}
			}
			USE_FPU {
				if {[string match $arg_value "1"]} {
				   	puts $config_file2 "PLATFORM_CPPFLAGS += -mhard-float"
				}
			}
			PVR {
				   	puts $config_file "#define XILINX_PVR\t$arg_value"
			}
			default {}
		}
           }
# OPB bus resolve
	   set dopb2 [xget_handle $hwproc_handle "BUS_INTERFACE" "DOPB"]
	   set dopb [xget_value $dopb2 "VALUE"]
	   set iopb [xget_handle $hwproc_handle "BUS_INTERFACE" "IOPB"]
	   set iopb [xget_value $iopb "VALUE"]
	   if { $dopb == $iopb } {
		set system_bus "$dopb"
		puts "System bus for instruction and data $dopb"

#testing

#	    set bus [xget_sw_parameter_value $os_handle "opb_v20"]
##	    set bus_handle [xget_sw_ipinst_handle_from_processor $proc_handle $bus]
##	    set hodn [xget_sw_parameter_value $bus_handle "C_EXT_RESET_HIGH"]
#	    puts "fdf $bus fds"
#		set clk [xget_handle $dopb "PORT" "OPB_Clk"]
#		puts "$clk"
#		set clk [xget_value $clk "VALUE"]
#		error "$clk"
#end testing
	   } else {
		error "different microblaze architecture - dual busses $iopb $dopb"
	   }


        }
       "ppc405" -
       "ppc405_virtex4" {
            puts "unsupported processor type $proctype\n"
            error "ERROR $proc_type not supported"
        }

        default {
        	error "This type of CPU is not supported"
        }
    }
    puts $config_file ""
# ************************************************************************************************************
# Interrupt controler
    set intc [xget_sw_parameter_value $os_handle "intc"]
    if {[string match "" $intc] || [string match -nocase "none" $intc]} {
            puts $config_file "/* Interrupt controller not defined */"
    } else {
	    puts $config_file "/* Interrupt controller is $intc */"
	    set intc_handle [xget_sw_ipinst_handle_from_processor $proc_handle $intc]
#test for correct system bus
	   test_buses $system_bus $intc_handle "SOPB"
# Interrupt controller address
	    set baseaddr_value [xget_sw_parameter_value $intc_handle "C_BASEADDR"]
            set baseaddr_value [format "0x%08x" $baseaddr_value]
	    puts $config_file "#define XILINX_INTC_BASEADDR\t$baseaddr_value"
	    set intr_value [xget_sw_parameter_value $intc_handle "C_NUM_INTR_INPUTS"]



	    puts $config_file "#define XILINX_INTC_NUM_INTR_INPUTS\t$intr_value"
	    set intr_value [expr $intr_value - 1]
	    set intc_handle [xget_sw_ipinst_handle_from_processor $proc_handle $intc]
    	    set port_list [xget_port_by_subtype $intc_handle "*"]
    	    foreach port $port_list {
    	     	    set name [xget_value $port "NAME"]
    	     	    if {[string match -nocase $name "intr"]} {
		       	    set intr_irq [xget_value $port "VALUE"]
#DEBUG		       	    puts $config_file "/* pripojene interrupty $name=$intr_irq */"
		       	    set intr_signals [split $intr_irq "&"]
		       	    #spit the signals
#DEBUG		       	    puts $config_file "$signals"
    	     	    }
    	    }
	    puts $config_file ""
# ************************************************************************************************************
# Timer part
# handle timer if exists intc
	    set timer [xget_sw_parameter_value $os_handle "timer"]
		    if {[string match "" $timer] || [string match -nocase "none" $timer]} {
		            puts $config_file "/* Timer not defined */"
		    } else {
			    set timer_handle [xget_sw_ipinst_handle_from_processor $proc_handle $timer]
#test for correct system bus
			   test_buses $system_bus $timer_handle "SOPB"
			    set timer_start [xget_sw_parameter_value $timer_handle "C_BASEADDR"]
			    set timer_start [format "0x%08x" $timer_start]
			    puts $config_file "/* Timer pheriphery is $timer */"
			    puts $config_file "#define XILINX_TIMER_BASEADDR\t$timer_start"

			    if {![string match "" $intc] && ![string match -nocase "none" $intc]} {
				    set port_list [xget_port_by_subtype $timer_handle "*"]
				    foreach port $port_list {
						set name [xget_value $port "NAME"]
#DEBUG						puts "name:$name = $port" # finding proper port
				     	    	if {[string match -nocase $name "interrupt"]} {
				  	     	    set value [xget_value $port "VALUE"]
			   	  	     	        #correct name of interrupt wire
#DEBUG							puts "value=$value"
							set delka $intr_value
							foreach i $intr_signals {
#							FIXME I don't know what exactly do
								set i [string trim $i]
							     	    if {[string match -nocase $i $value]} {
							     	        puts $config_file "#define XILINX_TIMER_IRQ\t$delka"
							     	    }
#DEBUG							    	    else {puts "nesedi"}
							     	set delka [expr $delka - 1]
							}
						    }
				     	    }
			     }
		    }
     }
    puts $config_file ""
# ************************************************************************************************************
# UartLite driver - I suppose, only uartlite driver
    set uart [xget_sw_parameter_value $os_handle "stdin_out"]
    if {[string match "" $uart] || [string match -nocase "none" $uart]} {
            puts $config_file "/* Uart not defined */"
            error "ERROR Uart not specified. Please specific console"
    } else {
	    set uart_handle [xget_sw_ipinst_handle_from_processor $proc_handle $uart]
	    puts $config_file "/* Uart pheriphery is $uart */"
	    set type [xget_value $uart_handle "VALUE"]
	    switch $type {
			"opb_uart16550" {
#				    puts $config_file "#define XILINX_UART16550"
				    set uart_baseaddr [xget_sw_parameter_value $uart_handle "C_BASEADDR"]
				    set uart_baseaddr [format "0x%08x" $uart_baseaddr]
				    puts $config_file "#define XILINX_UART16550_BASEADDR\t$uart_baseaddr"
# FIXME bad sysclock frequency
#				    puts $config_file "#define XILINX_UART16550_CLOCK_HZ\t$system_bus"
#it is driver dependent code
				    set drv_handle [xget_handle $proc_handle "DRIVER" "uartns550"]
				    if { [llength $drv_handle] == 0 } {
					error "Please specify your standalone driver for Uart16550"
				    }
				    puts $config_file "#define XILINX_UART16550_CLOCK_HZ\t[xget_value $drv_handle "PARAMETER" "CLOCK_HZ"]"
#dependent end
			}
			"opb_uartlite" {
				set args [xget_sw_parameter_handle $uart_handle "*"]
		    	    	foreach arg $args {
					set arg_name [xget_value $arg "NAME"]
		    			set arg_value [xget_value $arg "VALUE"]
					set arg_name [string map -nocase {C_ ""} $arg_name]
#DEBUG		        		puts $config_file "$arg_name $arg_value"
					case $arg_name in {
				    		{"BASEADDR" "BAUDRATE"} {
							puts $config_file "#define XILINX_UARTLITE_${arg_name}\t$arg_value"
						}
						default	{}
					}
				}
			}
			default {
				   error "Unsupported type of console - $type"
			}
		}
    }
    puts $config_file ""
# ************************************************************************************************************
# IIC driver - I suppose, only uartlite driver
    set iic [xget_sw_parameter_value $os_handle "iic"]
    if {[string match "" $iic] || [string match -nocase "none" $iic]} {
            puts $config_file "/* IIC doesn't exist */"
    } else {
	    set iic_handle [xget_sw_ipinst_handle_from_processor $proc_handle $iic]
	    set iic_baseaddr [xget_sw_parameter_value $iic_handle "C_BASEADDR"]
	    set iic_baseaddr [format "0x%08x" $iic_baseaddr]
	    set iic_freq [xget_sw_parameter_value $iic_handle "C_IIC_FREQ"]
	    set iic_bit [xget_sw_parameter_value $iic_handle "C_TEN_BIT_ADR"]
	    puts $config_file "/* IIC pheriphery is $iic */"
	    puts $config_file "#define XILINX_IIC_0_BASEADDR\t$iic_baseaddr"
	    puts $config_file "#define XILINX_IIC_0_FREQ\t$iic_freq"
	    puts $config_file "#define XILINX_IIC_0_BIT\t$iic_bit"
    }
    puts $config_file ""
# ************************************************************************************************************
# GPIO configuration
    set gpio [xget_sw_parameter_value $os_handle "gpio"]
    if {[string match "" $gpio] || [string match "none" $gpio]} {
      	 puts $config_file "/* GPIO doesn't exist */"
    } else {
         set base_param_name [format "C_BASEADDR" $gpio]
	 set gpio_handle [xget_sw_ipinst_handle_from_processor $proc_handle $gpio]
	 set gpio_start [xget_sw_parameter_value $gpio_handle $base_param_name]
	 set gpio_start [format "0x%08x" $gpio_start]
	 puts $config_file "/* GPIO is $gpio*/"
	 puts $config_file "#define XILINX_GPIO_BASEADDR\t$gpio_start"
    }
    puts $config_file ""
# ************************************************************************************************************
# Flash memory
  	set flash_mem [xget_sw_parameter_value $os_handle "flash_memory"]
     if {[string match "" $flash_mem] || [string match "none" $flash_mem]} {
      	 puts $config_file "/* FLASH doesn't exist $flash_mem */"
      	 puts "FLASH doesn't exists"
     } else {
	set flash_mem_handle [xget_sw_ipinst_handle_from_processor $proc_handle $flash_mem]
        set flash_mem_bank [xget_sw_parameter_value $os_handle "flash_memory_bank"]
	set base_param_name [format "C_MEM%i_BASEADDR" $flash_mem_bank]
	set high_param_name [format "C_MEM%i_HIGHADDR" $flash_mem_bank]
	set flash_start [xget_sw_parameter_value $flash_mem_handle $base_param_name]
	set flash_end [xget_sw_parameter_value $flash_mem_handle $high_param_name]
	set flash_size [expr $flash_end - $flash_start + 1]
	set flashm_start [format "0x%08x" $flash_start]
	set flash_size [format "0x%08x" $flash_size]
	puts $config_file "/* Flash Memory is $flash_mem */"
	puts $config_file "#define XILINX_FLASH_START\t$flash_start"
	puts $config_file "#define XILINX_FLASH_SIZE\t$flash_size"
    }
    puts $config_file ""
# ************************************************************************************************************
# System memory
    set main_mem [xget_sw_parameter_value $os_handle "main_memory"]
    if {[string match "" $main_mem] || [string match "none" $main_mem]} {
         error "ERROR main_memory not specified. Please specific main_memory"
    } else {
	    set main_mem_bank [xget_sw_parameter_value $os_handle "main_memory_bank"]
	    set main_mem_handle [xget_sw_ipinst_handle_from_processor $proc_handle $main_mem]
	    if {[string compare -nocase $main_mem_handle ""] != 0} {
	        set base_param_name [format "C_MEM%i_BASEADDR" $main_mem_bank]
	        set high_param_name [format "C_MEM%i_HIGHADDR" $main_mem_bank]
		set eram_base [xget_sw_parameter_value $main_mem_handle $base_param_name]
		set eram_end [xget_sw_parameter_value $main_mem_handle $high_param_name]
		set eram_size [expr $eram_end - $eram_base + 1]
		set eram_base [format "0x%08x" $eram_base]
		set eram_size [format "0x%08x" $eram_size]
		set eram_high [expr $eram_base + $eram_size]
		set eram_high [format "0x%08x" $eram_high]
		puts $config_file "/* Main Memory is $main_mem */"
		puts $config_file "#define XILINX_RAM_START\t$eram_base"
		puts $config_file "#define XILINX_RAM_SIZE\t$eram_size"
	    }
    }
    puts $config_file ""
# ************************************************************************************************************
# Sysace
     set sysace [xget_sw_parameter_value $os_handle "sysace"]
     if {[string match "" $sysace] || [string match "none" $sysace]} {
      	 puts $config_file "/* Sysace doesn't exist */"
     } else {
	    puts $config_file "/* Sysace Controller is $sysace */"
	    set sysace_handle [xget_sw_ipinst_handle_from_processor $proc_handle $sysace]
    	    set args [xget_sw_parameter_handle $sysace_handle "*"]
	    	    foreach arg $args {
			set arg_name [xget_value $arg "NAME"]
			set arg_name [string map -nocase {C_ ""} $arg_name]
#		        puts $config_file "$arg_name $arg_value"
			case $arg_name in {
			    {"BASEADDR" "MEM_WIDTH"} {
			    		set arg_value [xget_value $arg "VALUE"]
					puts $config_file "#define XILINX_SYSACE_${arg_name}\t$arg_value"
					}
			    default	{}
			}
	    }
    }
    puts $config_file ""
# ************************************************************************************************************
# Ethernet
    set ethernet [xget_sw_parameter_value $os_handle "ethernet"]
    if {[string match "" $iic] || [string match -nocase "none" $ethernet]} {
            puts $config_file "/* Ethernet doesn't exist */"
    } else {
	    set ethernet_handle [xget_sw_ipinst_handle_from_processor $proc_handle $ethernet]
		set ethernet_name [xget_value $ethernet_handle "VALUE"]
		puts "DEBUG $ethernet_name"
		puts $config_file "/* Ethernet controller is $ethernet */"

	    switch $ethernet_name {
			"opb_ethernet" {
				set args [xget_sw_parameter_handle $ethernet_handle "*"]
		    	    	foreach arg $args {
					set arg_name [xget_value $arg "NAME"]
		    			set arg_value [xget_value $arg "VALUE"]
					set arg_name [string map -nocase {C_ ""} $arg_name]
#DEBUG		        		puts $config_file "$arg_name $arg_value"
					case $arg_name in {
				    		{"BASEADDR" "MII_EXIST" "DMA_PRESENT" "HALF_DUPLEX_EXIST"} {
							puts $config_file "#define XILINX_EMAC_${arg_name}\t$arg_value"
						}
						default	{}
					}
				}
			}
			"opb_ethernetlite" {
				set args [xget_sw_parameter_handle $ethernet_handle "*"]
		    	    	foreach arg $args {
					set arg_name [xget_value $arg "NAME"]
		    			set arg_value [xget_value $arg "VALUE"]
					set arg_name [string map -nocase {C_ ""} $arg_name]
#DEBUG		        		puts $config_file "$arg_name $arg_value"
					case $arg_name in {
				    		{"BASEADDR" "TX_PING_PONG" "RX_PING_PONG"} {
							puts $config_file "#define XILINX_EMACLITE_${arg_name}\t$arg_value"
						}
						default	{}
					}
				}
			}
			default {
				   error "Unsupported ethernet periphery - $ethernet_name"
			}
		}
    }
#*************************************************************************************************************
# U-BOOT position in memory
    set text_base [xget_sw_parameter_value $os_handle "uboot_position"]
    set text_base [format "0x%08x" $text_base]
    puts $config_file2 ""
    if {$text_base == 0} {
    	puts $config_file2 "TEXT_BASE = $eram_base"
    	puts "WARNING automatic U-BOOT position"
    } elseif {$eram_base < $text_base && $eram_high > $text_base} {
#	    puts $config_file2 "# TEXT BASE "
	    puts $config_file2 "TEXT_BASE = $text_base"
	    puts $config_file2 ""
# print system clock
#    set sw [xget_sw_parameter_value $proc_handle "HW_INSTANCE"]

# FIXME Parameters for Microblaze from MHS files - look at Microblaze SW manual
# print microblaze params
#    set hwproc_handle [xget_handle $proc_handle "IPINST"]
#    set args [xget_hw_parameter_handle $hwproc_handle "*"]
#    set proctype [xget_value $hwproc_handle "OPTION" "IPNAME"]
    } else {
      	    error "ERROR u-boot position is out of range $eram_base - $eram_high"
    }

    close $config_file
    close $config_file2
#*************************************************************************************************************
}

##################################################
# procedure post_generate
# This generates the drivers directory for uboot
# and runs the ltypes script
##################################################

proc post_generate {lib_handle} {
    set pwd [pwd]
    set name [xget_value $lib_handle "PARAMETER" name]
    if {$name != ""} {
	    set uboot_dir "uboot/board/xilinx/$name"
	    exec bash -c "mkdir -p $uboot_dir"
	    exec bash -c "cp ../../include/xparameters.h $uboot_dir/xparameters-edk.h"
	    exec bash -c "cp ../../../system.mhs $uboot_dir"
	    exec bash -c "cp ../../../system.mss $uboot_dir"
	    exec bash -c "mv xparameters.h $uboot_dir"
	    exec bash -c "mv config.mk $uboot_dir"
    }
}

proc headerm {config_file2} {
     puts $config_file2 "\#"
     puts $config_file2 "\# (C) Copyright 2007 Michal Simek"
     puts $config_file2 "\#"
     puts $config_file2 "\# Michal  SIMEK <monstr@monstr.eu>"
     puts $config_file2 "\#"
     puts $config_file2 "\# See file CREDITS for list of people who contributed to this"
     puts $config_file2 "\# project."
     puts $config_file2 "\#"
     puts $config_file2 "\# This program is free software; you can redistribute it and/or"
     puts $config_file2 "\# modify it under the terms of the GNU General Public License as"
     puts $config_file2 "\# published by the Free Software Foundation; either version 2 of"
     puts $config_file2 "\# the License, or (at your option) any later version."
     puts $config_file2 "\#"
     puts $config_file2 "\# This program is distributed in the hope that it will be useful,"
     puts $config_file2 "\# but WITHOUT ANY WARRANTY; without even the implied warranty of"
     puts $config_file2 "\# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the"
     puts $config_file2 "\# GNU General Public License for more details."
     puts $config_file2 "\#"
     puts $config_file2 "\# You should have received a copy of the GNU General Public License"
     puts $config_file2 "\# along with this program; if not, write to the Free Software"
     puts $config_file2 "\# Foundation, Inc., 59 Temple Place, Suite 330, Boston,"
     puts $config_file2 "\# MA 02111-1307 USA"
     puts $config_file2 "\#"
     puts $config_file2 "\# CAUTION: This file is automatically generated by libgen."
     puts $config_file2 "\# Version: [xget_swverandbld]"
     puts $config_file2 "\#"
}

proc headerc {config_file2} {
     puts $config_file2 "/*"
     puts $config_file2 " * (C) Copyright 2007 Michal Simek"
     puts $config_file2 " *"
     puts $config_file2 " * Michal  SIMEK <monstr@monstr.eu>"
     puts $config_file2 " *"
     puts $config_file2 " * See file CREDITS for list of people who contributed to this"
     puts $config_file2 " * project."
     puts $config_file2 " *"
     puts $config_file2 " * This program is free software; you can redistribute it and/or"
     puts $config_file2 " * modify it under the terms of the GNU General Public License as"
     puts $config_file2 " * published by the Free Software Foundation; either version 2 of"
     puts $config_file2 " * the License, or (at your option) any later version."
     puts $config_file2 " *"
     puts $config_file2 " * This program is distributed in the hope that it will be useful,"
     puts $config_file2 " * but WITHOUT ANY WARRANTY; without even the implied warranty of"
     puts $config_file2 " * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the"
     puts $config_file2 " * GNU General Public License for more details."
     puts $config_file2 " *"
     puts $config_file2 " * You should have received a copy of the GNU General Public License"
     puts $config_file2 " * along with this program; if not, write to the Free Software"
     puts $config_file2 " * Foundation, Inc., 59 Temple Place, Suite 330, Boston,"
     puts $config_file2 " * MA 02111-1307 USA"
     puts $config_file2 " *"
     puts $config_file2 " * CAUTION: This file is automatically generated by libgen."
     puts $config_file2 " * Version: [xget_swverandbld]"
     puts $config_file2 " */"
}


# from xillib_hw.tcl
#
# Return the handle to the bus interface associated with this address parameter.
# Parameters: periph_handle: peripheral handle
#             addr_name: name of an address parameter
#
proc xget_addrparam_busif {periph_handle addr_param_name} {
    set baseaddr_handle [xget_handle $periph_handle "PARAMETER" $addr_param_name]
# test on null parameter
    if { [llength $baseaddr_handle] == 0 } {
	return ""
    }

    set baseaddr_bushandle [xget_handle $baseaddr_handle "SUBPROPERTY" "BUS"]
    puts "DEBUG $baseaddr_bushandle =="
    if { [llength $baseaddr_bushandle] == 0 } {
	# See if this address has a pair
	if {[string match *_BASEADDR $addr_param_name]} {
	    set addr_pair [string range $addr_param_name 0 [expr [string last "_BASEADDR" $addr_param_name] -1]]
	    append addr_pair "_HIGHADDR"
	} elseif {[string match *_HIGHADDR $addr_param_name]} {
	    set addr_pair [string range $addr_param_name 0 [expr [string last "_HIGHADDR" $addr_param_name] -1]]
	    append addr_pair "_BASEADDR"
	} else {
	    return ""
	}
	set baseaddr_handle [xget_handle $periph_handle "PARAMETER" $addr_pair]
	set baseaddr_bushandle [xget_handle $baseaddr_handle "SUBPROPERTY" "BUS"]
	if { [llength $baseaddr_bushandle] == 0 } {
	    return ""
	}
    }
    set baseaddr_busname [xget_value $baseaddr_handle "SUBPROPERTY" "BUS"]
#    set baseaddr_busname [xget_value $baseaddr_bushandle "VALUE"]
    set busif_handle [xget_handle $periph_handle "BUS_INTERFACE" $baseaddr_busname]
    return $busif_handle
}

#test for peripheral - if is correct setting system bus
proc test_buses {system_bus handle bus_type} {
	   set bus [xget_handle $handle "BUS_INTERFACE" $bus_type]
	   set bus [xget_value $bus "VALUE"]
	   if { $bus != $system_bus} {
	   	error "Periphery $handle is connected to another system bus ----"
	   } else {
	   	set name [xget_value $handle "NAME"]
	   	puts "$name has correct system_bus $system_bus"
	   }
	   return 1
}

#testovaci procedury

proc xdefine_include_file2 {drv_handle file_name drv_string args} {
    foreach arg $args {
	set value [xget_value $drv_handle "PARAMETER" $arg]
	if {[llength $value] == 0} {
		error "Zero size of PARAMETER. Please append argument args."
	} else {
#	    puts $file_name "#defineoo [xget_dname $drv_string $arg] [xget_value $drv_handle "PARAMETER" $arg]"
	    return [xget_value $drv_handle "PARAMETER" $arg]
	}
    }
}



